Attribute VB_Name = "DnaOps"
' here I have started to transfer some of the
' mutation procedures. It would be much more
' elegant to have them all here
' If they work, it'll be even more elegant

Const MaxDna As Integer = 1000

Type block
  tipo As Byte
  value As Integer
End Type

Public Function StringDNA(dna() As block) As String
  Dim t As Integer
  Dim a As String
  Dim gn As Integer
  Dim va As Integer
  Dim d As String
  d = ""
  t = 1
  gn = 1
  While Not (dna(t).tipo = 4 And dna(t).value = 4)
    ti = dna(t).tipo
    va = dna(t).value
    d = d + CStr(t) + ": "
    Select Case dna(t).tipo
      Case 0
        If dna(t + 1).tipo = 2 And dna(t + 1).value = 1 Then
          d = d + "  " + CStr(va)
        Else
          d = d + " " + Str$(va)
        End If
      Case 1
        a = CStr(va)
        d = d + "  " + "*" + a
      Case 2
        Select Case va
          Case 1
            d = d + "  store"
          Case 3
            d = d + "  add"
          Case 4
            d = d + "  sub"
          Case 5
            d = d + "  mult"
          Case 6
            d = d + "  div"
          Case 7
            d = d + "  rnd"
          Case 8
            d = d + "  inc"
          Case 9
            d = d + "  dec"
        End Select
      Case 3
        Select Case va
          Case 1
            d = d + "  <"
          Case 2
            d = d + "  >"
          Case 3
            d = d + "  ="
          Case 4
            d = d + "  !="
          Case 5
            d = d + "  %="
          Case 6
            d = d + "  !%="
        End Select
      Case 4
        Select Case va
          Case 1
            d = d + ""
            d = d + "cond"
          Case 2
            d = d + "start"
          Case 3
            gn = gn + 1
            d = d + "stop" + vbCrLf + "--------------" + Str(gn)
          Case 4
            d = d + "end"
        End Select
      End Select
      d = d + vbCrLf
    t = t + 1
  Wend
  d = d + "end"
  StringDNA = d
End Function

Public Function CheckIntegrity(ByRef dna() As block) As Boolean
  CheckIntegrity = True
  Dim k As Integer, f As Integer, j As Integer
  k = 1
  f = NextElement(dna, 1, 4, 4)
  If f < 0 Then CheckIntegrity = False
  While f > 0 And f > k And CheckIntegrity
    CheckIntegrity = False
    k = NextElement(dna, k, 4, 1)
    If k > 0 And dna(NextType(dna, k + 1, 4)).value = 2 Then
      k = NextElement(dna, k, 4, 2)
      If k > 0 And dna(NextType(dna, k + 1, 4)).value = 3 Then
        k = NextElement(dna, k, 4, 3)
        j = dna(NextType(dna, k + 1, 4)).value
        If j = 1 Or j = 4 Then CheckIntegrity = True
        If k < 0 Then CheckIntegrity = False
      End If
    End If
    k = k + 1
  Wend
  'If NextElement(dna, 1, 4, 4) > 0 Then CheckIntegrity = True
End Function

Public Function DnaLen(ByRef dna() As block) As Integer
  Dim k As Integer
  While k < MaxDna And Not (dna(k).tipo = 4 And dna(k).value = 4)
    k = k + 1
  Wend
  If Not (dna(k).tipo = 4 And dna(k).value = 4) Then k = -1
  DnaLen = k
End Function

Public Function NextElement(ByRef dna() As block, inizio As Integer, tipo As Integer, valore As Integer) As Integer
  Dim k As Integer
  k = inizio
  If inizio > 0 Then
    While k < MaxDna And Not (dna(k).tipo = 4 And dna(k).value = 4) And Not (dna(k).tipo = tipo And dna(k).value = valore)
      k = k + 1
    Wend
    If Not (dna(k).tipo = tipo And dna(k).value = valore) Then k = -1
  Else
    k = -1
  End If
  NextElement = k
End Function

Public Function PrevElement(ByRef dna() As block, inizio As Integer, tipo As Integer, valore As Integer) As Integer
  Dim k As Integer
  k = inizio
  If inizio > 0 Then
    While k > 0 And Not (dna(k).tipo = tipo And dna(k).value = valore)
      k = k - 1
    Wend
    If Not (dna(k).tipo = tipo And dna(k).value = valore) Then k = -1
  Else
    k = -1
  End If
  PrevElement = k
End Function

Public Function NextType(ByRef dna() As block, inizio As Integer, tipo As Integer) As Integer
  Dim k As Integer
  k = inizio
  While k < MaxDna And Not (dna(k).tipo = 4 And dna(k).value = 4) And Not (dna(k).tipo = tipo)
    k = k + 1
  Wend
  If Not (dna(k).tipo = tipo) Then k = -1
  NextType = k
End Function

Public Function NextGene(ByRef dna() As block, inizio As Integer) As Integer
  NextGene = NextElement(dna, inizio, 4, 1)
End Function

Public Function NextStart(ByRef dna() As block, inizio As Integer) As Integer
  NextStart = NextElement(dna, inizio, 4, 2)
End Function

Public Function NextStop(ByRef dna() As block, inizio As Integer) As Integer
  NextStop = NextElement(dna, inizio, 4, 3)
End Function

Public Function MakeSpace(ByRef dna() As block, inizio As Integer, lunghezza As Integer) As Boolean
  ' procedura verificata, funziona
  Dim l As Integer, t As Integer
  l = DnaLen(dna)
  MakeSpace = False
  If l + lunghezza < MaxDna Then
    For t = l + lunghezza To inizio + lunghezza Step -1
      dna(t) = dna(t - lunghezza)
    Next t
    For t = inizio To inizio + lunghezza - 1
      dna(t).tipo = 0
      dna(t).value = 0
    Next t
    MakeSpace = True
  End If
End Function

Public Sub Delete(ByRef dna() As block, inizio As Integer, fine As Integer)
  ' testata: funziona perfettamente
  Dim l As Integer, t As Integer, lungh
  lungh = fine - inizio
  l = DnaLen(dna)
  If fine < MaxDna And l > 0 Then
    For t = inizio To l - lungh
      dna(t) = dna(t + lungh + 1)
    Next t
    For t = l - lungh + 1 To MaxDna
      dna(t).tipo = 0
      dna(t).value = 0
    Next t
  End If
End Sub

Public Function Copy(ByRef dna() As block, da As Integer, a As Integer, dove As Integer) As Boolean
  ' procedura verificata, funziona
  Dim k As Integer, l As Integer, t As Integer, dist As Integer
  Copy = False
  l = a - da
  If MakeSpace(dna, dove, l + 1) Then
    dist = dove - da
    For t = da To a
      dna(t + dist) = dna(t)
    Next t
    Copy = True
  End If
End Function

Public Function CountGenes(ByRef dna() As block) As Integer
  Dim k As Integer
  k = 1
  While k > 0
    k = NextGene(dna, k + 1)
    CountGenes = CountGenes + 1
  Wend
  If CountGenes = 1 And NextGene(dna, 1) < 0 Then CountGenes = 0
End Function

Public Function GenePos(ByRef dna() As block, n As Integer) As Integer
  Dim k As Integer
  Dim genenum As Integer
  GenePos = -1
  k = 1
  While k > 0 And GenePos < 0
    genenum = genenum + 1
    If genenum = n Then GenePos = k
    k = NextGene(dna, k + 1)
  Wend
End Function

Public Sub DuplicateRandomGene(ByRef dna() As block)
  Dim k As Integer, i As Integer, f As Integer
  k = Random(1, CountGenes(dna))
  i = GenePos(dna, k)
  f = NextStop(dna, i)
  Copy dna, i, f, f + 1
End Sub

Public Sub DeleteRandomGene(ByRef dna() As block)
  Dim k As Integer, i As Integer, f As Integer
  k = Random(1, CountGenes(dna))
  If k > 0 Then
    i = GenePos(dna, k)
    f = NextStop(dna, i)
    Delete dna, i, f
  End If
End Sub

Public Function ChangeValue(ByRef dna() As block, prob As Long, x As String) As Integer
  Dim t As Integer
  Dim a As Integer
  Dim b As Integer
  Dim k As Single
  t = 1
  ChangeValue = 0
  While Not (dna(t).tipo = 4 And dna(t).value = 4)
    If dna(t).tipo = 0 And Not (dna(t + 1).tipo = 2 And dna(t + 1).value = 1) Then
      If Random(1, prob) = 1 Then
        ChangeValue = ChangeValue + 1
        a = dna(t).value
        x = x + "Changed val " + CStr(a) + vbCrLf
        b = Abs(a) / 10
        If b < 1 Then b = 1
        k = a + PiuMeno * Gauss(1, a + PiuMeno * 10)
        If k < -32000 Then k = 32000
        If k > 32000 Then k = 32000
        dna(t).value = Int(k)
      End If
    End If
    t = t + 1
  Wend
End Function

Public Sub ImmediateToMem(ByRef dna() As block, pos As Integer)
  If dna(pos).tipo = 0 Then
    dna(pos).tipo = 1
    dna(pos).value = Abs(dna(pos).value Mod 1000)
  End If
End Sub

Public Sub MemToImmediate(ByRef dna() As block, pos)
  If dna(pos).tipo = 1 Then
    dna(pos).tipo = 0
    dna(pos).value = Random(0, 30000)
  End If
End Sub

Public Sub InstrToInstr(ByRef dna() As block, pos)
  Dim k As Integer
  If dna(pos).tipo = 2 Then
    k = Random(1, 9)
    While k = dna(pos).value Or k = 2
      k = Random(1, 9)
    Wend
    dna(pos).value = k
  End If
End Sub

Public Function DelRandomPos(ByRef dna() As block, prob As Long, x As String) As Integer
  Dim k As Integer, f As Integer, j As Integer
  DelRandomPos = 0
  k = NextStart(dna, 1)
  While k > 0
    f = NextStop(dna, k)
    j = k + 1
    While j < f
      If Random(1, prob) = 1 Then
        Delete dna, j, j
        f = NextStop(dna, k)
        x = x + "Deleted pos " + CStr(j) + vbCrLf
        DelRandomPos = DelRandomPos + 1
        If f < 0 Then
          MsgBox "dna corrotto in operazione delrandompos"
          Exit Function
        End If
      End If
      j = j + 1
    Wend
    k = NextStart(dna, f)
  Wend
End Function

Public Function DuplicateRandomInstr(dna() As block, x As String, prob As Long) As Integer
  Dim t As Integer
  Dim lun As Integer, spa As Integer
  Dim fdna As Integer
  t = 1
  DuplicateRandInstr = 0
  fdna = NextElement(dna, 1, 4, 4)
  For t = 1 To fdna
    If dna(t).tipo = 2 Then
      If Random(1, prob) = 1 Then
        spa = t - PrevElement(dna, t, 4, 2) - 1
        lun = 2
        If spa < 2 Then lun = spa
        If Copy(dna, t - lun, t, t + 1) Then
          x = x + "Duplicated instr at pos " + CStr(i) + vbCrLf
          DuplicateRandomInstr = DuplicateRandomInstr + 1
        End If
      End If
    End If
  Next t
End Function

Public Function ChangeRandomInstr(ByRef dna() As block, prob As Long, x As String) As Integer
  Dim i As Integer
  i = NextType(dna, 1, 2)
  While i > 0
    If Random(1, prob) = 1 Then
      InstrToInstr dna, i
      x = x + "Changed instr at pos " + CStr(i) + vbCrLf
      ChangeRandomInstr = ChangeRandomInstr + 1
    End If
    i = NextType(dna, i + 1, 2)
  Wend
End Function

Public Function InsertRandomInstr(ByRef dna() As block, prob As Long, x As String) As Integer
  Dim fd As Integer, pos As Integer, endg As Integer
  Dim ppos As Integer
  pos = 1
  fd = NextElement(dna, 1, 4, 4)
  While pos < fd
    If ppos = pos Then Exit Function
    ppos = pos
    pos = NextElement(dna, pos, 4, 2) + 1
    endg = NextElement(dna, pos, 4, 3)
    While pos <= endg
      If Random(1, prob) = 1 Then
        If MakeSpace(dna, pos, 1) Then
          dna(pos).tipo = 2
          dna(pos).value = Random(1, 9)
          x = x + "Inserted instr at pos " + CStr(i) + vbCrLf
          InsertRandomInstr = InsertRandomInstr + 1
        End If
      End If
      pos = pos + 1
    Wend
  Wend
End Function

Public Function SplitRandomPos(ByRef dna() As block, prob As Long, x As String) As Integer
  Dim k As Integer, f As Integer, j As Integer
  k = NextStart(dna, 1)
  While k > 0
    f = NextStop(dna, k)
    j = k + 1
    While j < f
      If Random(1, prob) = 1 Then
        If MakeSpace(dna, j, 3) Then
          dna(j).tipo = 4
          dna(j).value = 3
          dna(j + 1).tipo = 4
          dna(j + 1).value = 1
          dna(j + 2).tipo = 4
          dna(j + 2).value = 2
          j = j + 2
          x = x + "Random gene splitted" + vbCrLf
          SplitRandomPos = SplitRandomPos + 1
        End If
      End If
      j = j + 1
    Wend
    k = NextStart(dna, f)
  Wend
End Function

Public Function CopyAB(ByRef adna() As block, ByRef bdna() As block, da As Integer, a As Integer, dove As Integer)
  Dim k As Integer, l As Integer, t As Integer, dist As Integer
  'CopyAB = False
  l = a - da
  'If MakeSpace(bdna, dove, l + 1) Then
    dist = dove - da
    For t = da To a
      bdna(t + dist) = adna(t)
    Next t
    'CopyAB = True
  'End If
End Function

Public Function GeneCopyAB(ByRef adna() As block, bdna() As block, gene As Integer, last As Integer)
  Dim inizio As Integer, fine As Integer, dove As Integer
  inizio = GenePos(adna, gene)
  fine = NextStop(adna, inizio)
  dove = NextStop(bdna, GenePos(bdna, last - 1)) + 1
  If dove < 1 Then dove = 1
  CopyAB adna, bdna, inizio, fine, dove
End Function

Public Function CrossingOver(ByRef adna() As block, ByRef bdna() As block, ByRef CDna() As block)
  Dim aGenes As Integer, bGenes As Integer, cGenes As Integer
  Dim apiv As Integer, bpiv As Integer, cpiv As Integer, st As Boolean
  Dim pos As Integer
  aGenes = CountGenes(adna)
  bGenes = CountGenes(bdna)
  'Debug.Print aGenes, bGenes
  apiv = 1
  bpiv = 1
  cpiv = 1
  st = (Random(0, 1) = 1)
  While apiv <= aGenes And bpiv <= bGenes
    If st Then
      GeneCopyAB adna, CDna, apiv, cpiv
      'Debug.Print "copiato da A a C"
    Else
      GeneCopyAB bdna, CDna, bpiv, cpiv
      'Debug.Print "copiato da B a C"
    End If
    apiv = apiv + 1
    bpiv = bpiv + 1
    cpiv = cpiv + 1
    st = Not st
  Wend
  If Random(0, 1) = 1 Then
    While apiv <= aGenes
      GeneCopyAB adna, CDna, apiv, cpiv
      apiv = apiv + 2
      cpiv = cpiv + 1
    Wend
    While bpiv <= bGenes
      GeneCopyAB bdna, CDna, bpiv, cpiv
      bpiv = bpiv + 2
      cpiv = cpiv + 1
    Wend
  End If
  pos = NextStop(CDna, GenePos(CDna, cpiv - 1)) + 1
  'Debug.Print pos
  CDna(pos).tipo = 4
  CDna(pos).value = 4
End Function
