Attribute VB_Name = "SimOptModule"
' definition of the SimOpts structure

Public Type SimOptions
  '
  VisColorTies As Boolean
  '
  SimName As String
  TotRunCycle As Long
  TotRunTime As Long
  TotBorn As Long
  SpeciesNum As Integer
  Specie(50) As datispecie
  FieldSize As Integer
  FieldWidth As Long
  FieldHeight As Long
  MaxEnergy As Long
  MaxPopulation As Integer
  MinVegs As Integer
  KillDistVegs As Boolean
  BlockedVegs As Boolean
  DisableTies As Boolean
  PopLimMethod As Integer
  Toroidal As Boolean
  '
  CostExecCond As Single
  CostStore As Single
  CostChem As Single
  EnergyProp As Single
  EnergyFix As Integer
  EnergyExType As Boolean
  '
  PhysFriction As Single
  PhysGrav As Single
  PhysBrown As Single
  PhysSwim As Single
  PhysMoving As Single
  '
  AutoSimPath As String
  AutoSimTime As Integer
  AutoRobPath As String
  AutoRobTime As Integer
  '
  MutCurrMult As Single
  MutOscill As Boolean
  MutCycMax As Long
  MutCycMin As Long
  '
  DBName As String
  DBEnable As Boolean
  DBExcludeVegs As Boolean
  DBRecDna As Boolean
End Type

Public SimOpts As SimOptions

